// Variables to store command line options in, and function to parse them

#include <iosfwd>  // ostream
#include <string>

namespace args {
  using namespace std;
  typedef unsigned uint;

  extern string command;   // will hold the whole command line
  extern string seqfile;   // input file of fasta-format sequences
  extern uint runs;        // number of runs to perform from independent starts
  extern uint stop_after;  // stop each run after this many iterations without improvement
  extern bool one_strand;  // consider one or both strands?
  extern uint min_width;
  extern uint max_width;
  extern bool zoops;       // zoops or oops?
  extern string old_glam_file;  // previous alignments
  extern bool strict_subopt;  // ban all residues from being in > 1 alignment?
  extern uint flank_seq;   // # of flanking residues to print either side of the alignment
  extern bool mask_lower;  // mask lowercase letters?
  extern float resize_freq;  // how frequently to try resizing moves
  extern float init_temp;
  extern float cool_factor;
  extern bool lam;         // use modified lam schedule?
  extern bool even_bg;     // pretend residue abundances are 1/4 each
  extern float pseudocount_weight;
  extern bool even_pseudos;
  extern uint random_seed;
  extern bool all_aligns;  // print all alignments found, not just best one
  extern bool profile;     // print energy, accept rate, & other stats after each iteration
  extern bool want_evalue;

  void parse(int argc, char **argv);  // parse the arguments using getopt
}
