#ifndef NKSGLOBAL_
#define NKSGLOBAL_

#include <nks.h>
#include <nksio.h>

// Global Variables

#ifdef NKS_MAIN_
#define ext
#define beg(A, B)                     A = B
#else
#define ext                           extern
#define beg(A, B)                     extern A 
#endif

// Allocating Definitions

#define NKS_CATCH(x, y, message)          try { x; } catch (y) { Nks_AbortFormat ("%s : %s\n", message, #x); }   
#undef CATCH
#define CATCH                         NKS_CATCH
#define NKS_CATCHF(x, y, format, message) try { x; } catch (y) { Nks_AbortFormat (format, message); }   
#undef CATCHF
#define CATCHF                        NKS_CATCHF

// Debugging Definitions

#ifdef  DEBUG
#define DB(x)                         x
#define MSG(x)                        (void) Nks_AppendAndCloseFile ("debug.txt", x); \
                                      (void) Nks_AppendAndCloseFile ("debug.txt", "\n");
#define MSGF(x, y)                    (void) Nks_AppendAndCloseFile ("debug.txt", x, y); \
                                      (void) Nks_AppendAndCloseFile ("debug.txt", "\n");
#else
#define DB(x)
#define MSG(x)
#define MSGF(x, y)
#endif

// Array Definitions

#ifndef NKS_DIM1
#define NKS_DIM1(A)                   (sizeof A /sizeof *A)
#endif
#undef DIM1
#define DIM1 NKS_DIM1 

#ifndef SSIZE_MAX
#define SSIZE_MAX (1UL << (sizeof (size_t) * 8 - 1) - 1)
#endif

#endif // NKSGLOBAL_
