/*   nksintmath.c
* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================
*
* File Name:  nksintmath.cpp
*
* Author:  Spouge
*
* Version Creation Date:   08/07/2000
*
* $Revision: 1.1 $
*
*
* Modifications:
* --------------------------------------------------------------------------
* Date     Name        Description of modification
* -------  ----------  -----------------------------------------------------
*
*
*
* ==========================================================================
*/

#include <nksintmath.h>

long Nks_Mod (                    // Portable modular function %
long i,                           // number being divided
long j)                           // divisor 
{
   long abs_j = NKS_ABS(j);
   if (j == 0) {
Nks_Abort ("Nks_Mod : j == 0");   
   }
   if (i < 0) {
      long k = NKS_ABS(i) % abs_j;
return k == 0 ? k : abs_j - k;
   } else {
return i % NKS_ABS(j);
   }
};


