#ifndef NKSROOTFINDER_
#define NKSROOTFINDER_

#include <nks.h>
#include <nksmathdef.h>
#include <nksio.h>


double Nks_RootFinder (                      // finds root f(x) = y with derivative y'
double y,                                    // ordinate
double (*f) (double x),                      // function : param contains parameters
double (*df) (double x),                     // derivative of function
double p,                                    // interval end-point
double x,                                    // initial guess 
double q,                                    // interval end-point 
double tol,                                  // absolute tolerance
double rtol = 0.0);                          // relative tolerance

double Nks_RootBisection (                   // finds root f(x) = y
double y,                                    // f(x)=y
double (*f) (double x),                      // function : param contains parameters
double p,                                    // end-point
double q,                                    // end-point
double tol,                                  // absolute tolerance
double rtol = 0.0);                          // relative tolerance

double Nks_RootFinder (                      // finds root f(x) = y with derivative y'
double y,                                    // ordinate
double (*f) (double x, void *param),         // function : param contains parameters
double (*df) (double x, void *param),        // derivative of function
void *param,                                 // parameters for function
double p,                                    // interval end-point
double x,                                    // initial guess 
double q,                                    // interval end-point 
double tol,                                  // absolute tolerance
double rtol = 0.0);                          // relative tolerance

double Nks_RootBisection (                   // finds root f(x) = y
double y,                                    // f(x)=y
double (*f) (double x, void *param),         // function : param contains parameters
void *param,                                 // parameters for function
double p,                                    // end-point
double q,                                    // end-point
double tol,                                  // absolute tolerance
double rtol = 0.0);                          // relative tolerance

#undef RootFinder
#define RootFinder	                        Nks_RootFinder

#undef RootBisection
#define RootBisection                        Nks_RootBisection

#endif //!NKSROOTFINDER_
