// functions needed to calculate evalues of alignment scores

#include <vector>

namespace stats {
  using namespace std;
  typedef unsigned uint;

  // calculate the random walk parameters k and mustar
  void params(
    float & k,
    float & mustar,
    const vector<float> & probs,  // background residue probabilities
    const vector<float> & pseudos,  // pseudocounts
    uint seqnum);  // number of sequences

  // given a score, and other information, return the evalue
  float evalue(
    float score,  // alignment score
    float kstuff,  // single stranded: ln(k); double stranded: ln(k) + (seqnum-1) * ln(2)
    float mustar,  // same as that returned by params
    const vector<uint> & len);  // sequence lengths
}
